blob: 929fe884c54d73b2f7ca2badb807c75fca9d42fc [file] [log] [blame]
Peter Tyserf2352872009-12-06 23:58:28 -06001#!/bin/bash
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02002# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
Wolfgang Denkeca3aeb2013-06-21 10:22:36 +02005#
6# SPDX-License-Identifier: GPL-2.0+
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02007
Mike Frysingerd8e392d2011-04-21 22:01:43 +00008usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090021 -b BOARD, --board BOARD Build all boards with board name BOARD
Marek Vasut7f79c6f2011-12-02 21:32:03 +000022 -l, --list List all targets to be built
Marek Vasut9b96c6b2012-03-05 15:10:51 +000023 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
Kim Phillips33f336d2012-09-27 14:57:34 +000025 -C, --check Enable build checking
Joe Hershberger08510202012-10-30 15:55:21 +000026 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
Mike Frysingerd8e392d2011-04-21 22:01:43 +000028 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
Allen Martin47104c32013-01-29 14:34:58 +000041 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
Wolfgang Denk93e14592013-10-04 17:43:24 +020042 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
Mike Frysingerd8e392d2011-04-21 22:01:43 +000044 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
Andy Flemingf588bb02012-04-24 19:33:51 +000046 BUILD_NBUILDS number of parallel targets (default: 1)
Mike Frysingerd8e392d2011-04-21 22:01:43 +000047
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090063SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020065
66# Option processing based on util-linux-2.13/getopt-parse.bash
67
Wolfgang Denk071bc922010-10-27 22:48:30 +020068# Note that we use `"$@"' to let each command-line parameter expand to a
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020069# separate word. The quotes around `$@' are essential!
70# We need TEMP as the `eval set --' would nuke the return value of
71# getopt.
72TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
Mike Frysingerd8e392d2011-04-21 22:01:43 +000075[ $? != 0 ] && usage 1
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020076
77# Note the quotes around `$TEMP': they are essential!
78eval set -- "$TEMP"
79
80SELECTED=''
Marek Vasut7f79c6f2011-12-02 21:32:03 +000081ONLY_LIST=''
Marek Vasut9b96c6b2012-03-05 15:10:51 +000082PRINT_MAINTS=''
83MAINTAINERS_ONLY=''
Joe Hershberger08510202012-10-30 15:55:21 +000084CONTINUE=''
85REBUILD_ERRORS=''
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020086
87while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
Allen Martinaa2e2792012-08-31 08:30:06 +0000101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200102 else
Allen Martinaa2e2792012-08-31 08:30:06 +0000103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200111 else
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
Kim Phillips33f336d2012-09-27 14:57:34 +0000136 -C|--check)
137 CHECK='C=1'
138 shift ;;
Joe Hershberger08510202012-10-30 15:55:21 +0000139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
Mike Frysingerd8e392d2011-04-21 22:01:43 +0000157 -h|--help)
158 usage ;;
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164done
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900165
166GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
168 exit 1
169}
170
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200171# echo "Remaining arguments:"
172# for arg do echo '--> '"\`$arg'" ; done
173
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900174if [ ! -r boards.cfg ]; then
175 echo "Could not find boards.cfg"
176 tools/genboardscfg.py || {
177 echo "Failed to generate boards.cfg" >&2
178 exit 1
179 }
180fi
181
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200182FILTER="\$1 !~ /^#/"
183[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
184[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
185[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
186[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900187[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200188
189if [ "$SELECTED" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200190 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
Peter Tysercd57b0b2010-10-29 17:59:06 -0500191
192 # Make sure some boards from boards.cfg are actually found
193 if [ -z "$SELECTED" ] ; then
194 echo "Error: No boards selected, invalid arguments"
195 exit 1
196 fi
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200197fi
198
199#########################################################################
200
Peter Tyser40a28f02009-09-21 12:04:32 -0500201# Print statistics when we exit
202trap exit 1 2 3 15
203trap print_stats 0
204
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100205# Determine number of CPU cores if no default was set
206: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
207
208if [ "$BUILD_NCPUS" -gt 1 ]
209then
Peter Tyser55f786d2009-09-21 12:04:33 -0500210 JOBS="-j $((BUILD_NCPUS + 1))"
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100211else
212 JOBS=""
213fi
214
Marian Balakowiczf9328632006-09-01 19:49:50 +0200215if [ "${MAKEALL_LOGDIR}" ] ; then
216 LOG_DIR=${MAKEALL_LOGDIR}
217else
218 LOG_DIR="LOG"
219fi
Stefan Roese887e2ec2006-09-07 11:51:23 +0200220
Andy Flemingf588bb02012-04-24 19:33:51 +0000221: ${BUILD_NBUILDS:=1}
222BUILD_MANY=0
223
224if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
225 BUILD_MANY=1
226 : ${BUILD_DIR:=./build}
227 mkdir -p "${BUILD_DIR}/ERR"
228 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
Marian Balakowiczf9328632006-09-01 19:49:50 +0200229fi
230
Andy Flemingf588bb02012-04-24 19:33:51 +0000231: ${BUILD_DIR:=.}
232
233OUTPUT_PREFIX="${BUILD_DIR}"
234
235[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
Joe Hershberger08510202012-10-30 15:55:21 +0000236if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
237 find "${LOG_DIR}/" -type f -exec rm -f {} +
238fi
wdenk7ebf7442002-11-02 23:17:16 +0000239
240LIST=""
241
Peter Tyser40a28f02009-09-21 12:04:32 -0500242# Keep track of the number of builds and errors
243ERR_CNT=0
244ERR_LIST=""
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000245WRN_CNT=0
246WRN_LIST=""
Peter Tyser40a28f02009-09-21 12:04:32 -0500247TOTAL_CNT=0
Joe Hershberger08510202012-10-30 15:55:21 +0000248SKIP_CNT=0
Andy Flemingf588bb02012-04-24 19:33:51 +0000249CURRENT_CNT=0
250OLDEST_IDX=1
Peter Tyserf2352872009-12-06 23:58:28 -0600251RC=0
Peter Tyser40a28f02009-09-21 12:04:32 -0500252
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400253# Helper funcs for parsing boards.cfg
Masahiro Yamada89487942013-10-21 11:11:28 +0900254targets_by_field()
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400255{
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900256 field=$1
257 regexp=$2
258
259 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
260 boards.cfg
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400261}
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900262
Masahiro Yamada89487942013-10-21 11:11:28 +0900263targets_by_arch() { targets_by_field 2 "$@" ; }
264targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
265targets_by_soc() { targets_by_field 4 "$@" ; }
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400266
wdenk7ebf7442002-11-02 23:17:16 +0000267#########################################################################
wdenk0db5bca2003-03-31 17:27:09 +0000268## MPC5xx Systems
269#########################################################################
270
Masahiro Yamada89487942013-10-21 11:11:28 +0900271LIST_5xx="$(targets_by_cpu mpc5xx)"
wdenk0db5bca2003-03-31 17:27:09 +0000272
273#########################################################################
wdenk945af8d2003-07-16 21:53:01 +0000274## MPC5xxx Systems
275#########################################################################
276
Masahiro Yamada89487942013-10-21 11:11:28 +0900277LIST_5xxx="$(targets_by_cpu mpc5xxx)"
wdenk945af8d2003-07-16 21:53:01 +0000278
279#########################################################################
Rafal Jaworowski8993e542007-07-27 14:43:59 +0200280## MPC512x Systems
281#########################################################################
282
Masahiro Yamada89487942013-10-21 11:11:28 +0900283LIST_512x="$(targets_by_cpu mpc512x)"
wdenk7ebf7442002-11-02 23:17:16 +0000284
285#########################################################################
286## MPC8xx Systems
287#########################################################################
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400288
Masahiro Yamada89487942013-10-21 11:11:28 +0900289LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000290
291#########################################################################
292## PPC4xx Systems
293#########################################################################
294
Masahiro Yamada89487942013-10-21 11:11:28 +0900295LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000296
297#########################################################################
298## MPC824x Systems
299#########################################################################
300
Masahiro Yamada89487942013-10-21 11:11:28 +0900301LIST_824x="$(targets_by_cpu mpc824x)"
wdenk592c5ca2003-06-21 00:17:24 +0000302
wdenk7ebf7442002-11-02 23:17:16 +0000303#########################################################################
wdenk7aa78612003-05-03 15:50:43 +0000304## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk7ebf7442002-11-02 23:17:16 +0000305#########################################################################
306
Masahiro Yamada89487942013-10-21 11:11:28 +0900307LIST_8260="$(targets_by_cpu mpc8260)"
wdenk7ebf7442002-11-02 23:17:16 +0000308
309#########################################################################
Eran Libertyf046ccd2005-07-28 10:08:46 -0500310## MPC83xx Systems (includes 8349, etc.)
311#########################################################################
312
Masahiro Yamada89487942013-10-21 11:11:28 +0900313LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Libertyf046ccd2005-07-28 10:08:46 -0500314
315#########################################################################
wdenk42d1f032003-10-15 23:53:47 +0000316## MPC85xx Systems (includes 8540, 8560 etc.)
317#########################################################################
318
Masahiro Yamada89487942013-10-21 11:11:28 +0900319LIST_85xx="$(targets_by_cpu mpc85xx)"
wdenk42d1f032003-10-15 23:53:47 +0000320
321#########################################################################
Jon Loeliger822d5532007-05-23 14:09:46 -0500322## MPC86xx Systems
323#########################################################################
324
Masahiro Yamada89487942013-10-21 11:11:28 +0900325LIST_86xx="$(targets_by_cpu mpc86xx)"
Jon Loeliger822d5532007-05-23 14:09:46 -0500326
327#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000328## 74xx/7xx Systems
329#########################################################################
330
Masahiro Yamada89487942013-10-21 11:11:28 +0900331LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000332
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700333#########################################################################
334## PowerPC groups
335#########################################################################
336
337LIST_TSEC=" \
338 ${LIST_83xx} \
339 ${LIST_85xx} \
340 ${LIST_86xx} \
341"
342
Stefan Roesea47a12b2010-04-15 16:07:28 +0200343LIST_powerpc=" \
Kim Phillipsfb565792007-08-10 15:34:48 -0500344 ${LIST_5xx} \
Jean-Christophe PLAGNIOL-VILLARD3deca9d2007-11-25 22:39:25 +0100345 ${LIST_512x} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500346 ${LIST_5xxx} \
347 ${LIST_8xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500348 ${LIST_824x} \
349 ${LIST_8260} \
350 ${LIST_83xx} \
351 ${LIST_85xx} \
352 ${LIST_86xx} \
353 ${LIST_4xx} \
Wolfgang Denk2ae18242010-10-06 09:05:45 +0200354 ${LIST_74xx_7xx}\
Kim Phillipsfb565792007-08-10 15:34:48 -0500355"
wdenk7ebf7442002-11-02 23:17:16 +0000356
Stefan Roesea47a12b2010-04-15 16:07:28 +0200357# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
358# still using "ppc" instead of "powerpc"
359LIST_ppc=" \
360 ${LIST_powerpc} \
361"
362
wdenk7ebf7442002-11-02 23:17:16 +0000363#########################################################################
364## StrongARM Systems
365#########################################################################
366
Masahiro Yamada89487942013-10-21 11:11:28 +0900367LIST_SA="$(targets_by_cpu sa1100)"
wdenk7ebf7442002-11-02 23:17:16 +0000368
369#########################################################################
Allen Martincce5d212012-08-29 11:08:59 +0000370## ARM7 Systems
371#########################################################################
372
Masahiro Yamada89487942013-10-21 11:11:28 +0900373LIST_ARM7="$(targets_by_cpu arm720t)"
Allen Martincce5d212012-08-29 11:08:59 +0000374
375#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000376## ARM9 Systems
377#########################################################################
378
Masahiro Yamada89487942013-10-21 11:11:28 +0900379LIST_ARM9="$(targets_by_cpu arm920t) \
380 $(targets_by_cpu arm926ejs) \
381 $(targets_by_cpu arm946es) \
wdenk6f213472003-08-29 22:00:43 +0000382"
wdenk7ebf7442002-11-02 23:17:16 +0000383
384#########################################################################
wdenk8ed96042005-01-09 23:16:25 +0000385## ARM11 Systems
386#########################################################################
Masahiro Yamada89487942013-10-21 11:11:28 +0900387LIST_ARM11="$(targets_by_cpu arm1136) \
388 $(targets_by_cpu arm1176) \
Allen Martincce5d212012-08-29 11:08:59 +0000389"
wdenk8ed96042005-01-09 23:16:25 +0000390
391#########################################################################
Steve Sakomanf56348a2010-06-17 21:50:01 -0700392## ARMV7 Systems
Dirk Behmef904cdb2009-01-27 18:19:12 +0100393#########################################################################
Dirk Behmef37586b2011-08-05 20:48:32 +0000394
Masahiro Yamada89487942013-10-21 11:11:28 +0900395LIST_ARMV7="$(targets_by_cpu armv7)"
Dirk Behmef904cdb2009-01-27 18:19:12 +0100396
397#########################################################################
David Feng2475e632013-12-14 11:47:38 +0800398## ARMV8 Systems
399#########################################################################
400
401LIST_ARMV8="$(targets_by_cpu armv8)"
402
403#########################################################################
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200404## AT91 Systems
405#########################################################################
406
Masahiro Yamada89487942013-10-21 11:11:28 +0900407LIST_at91="$(targets_by_soc at91)"
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200408
409#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000410## Xscale Systems
411#########################################################################
412
Masahiro Yamada89487942013-10-21 11:11:28 +0900413LIST_pxa="$(targets_by_cpu pxa)"
wdenk7ebf7442002-11-02 23:17:16 +0000414
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700415#########################################################################
Stefan Roese24dede42012-05-30 22:59:43 +0000416## SPEAr Systems
417#########################################################################
418
Masahiro Yamada89487942013-10-21 11:11:28 +0900419LIST_spear="$(targets_by_soc spear)"
Stefan Roese24dede42012-05-30 22:59:43 +0000420
421#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700422## ARM groups
423#########################################################################
wdenk2d5b5612003-10-14 19:43:55 +0000424
David Feng2475e632013-12-14 11:47:38 +0800425LIST_arm="$(targets_by_arch arm | \
426 for ARMV8_TARGET in $LIST_ARMV8; \
427 do sed "/$ARMV8_TARGET/d"; \
428 done) \
429"
wdenk7ebf7442002-11-02 23:17:16 +0000430
wdenkc0218802003-03-27 12:09:35 +0000431#########################################################################
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200432## MIPS Systems (default = big endian)
wdenkc0218802003-03-27 12:09:35 +0000433#########################################################################
434
Daniel Schwierzecked638b62014-04-17 21:45:59 +0200435LIST_mips="$(targets_by_arch mips)"
wdenkc0218802003-03-27 12:09:35 +0000436
Stefan Kristianssondeddf5d2011-11-18 19:21:37 +0000437#########################################################################
438## OpenRISC Systems
439#########################################################################
440
Masahiro Yamada89487942013-10-21 11:11:28 +0900441LIST_openrisc="$(targets_by_arch openrisc)"
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200442
443#########################################################################
Graeme Russfea25722011-04-13 19:43:28 +1000444## x86 Systems
wdenk7a8e9bed2003-05-31 18:35:21 +0000445#########################################################################
446
Masahiro Yamada89487942013-10-21 11:11:28 +0900447LIST_x86="$(targets_by_arch x86)"
wdenk7a8e9bed2003-05-31 18:35:21 +0000448
wdenkc935d3b2004-01-03 19:43:48 +0000449#########################################################################
wdenk5c952cf2004-10-10 21:27:30 +0000450## Nios-II Systems
451#########################################################################
452
Masahiro Yamada89487942013-10-21 11:11:28 +0900453LIST_nios2="$(targets_by_arch nios2)"
wdenk5c952cf2004-10-10 21:27:30 +0000454
455#########################################################################
wdenk857cad32004-07-10 23:48:41 +0000456## MicroBlaze Systems
457#########################################################################
458
Masahiro Yamada89487942013-10-21 11:11:28 +0900459LIST_microblaze="$(targets_by_arch microblaze)"
wdenk857cad32004-07-10 23:48:41 +0000460
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500461#########################################################################
462## ColdFire Systems
463#########################################################################
464
Masahiro Yamada89487942013-10-21 11:11:28 +0900465LIST_m68k="$(targets_by_arch m68k)"
Mike Frysingerc13f47b2011-09-25 19:27:19 +0000466LIST_coldfire=${LIST_m68k}
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500467
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200468#########################################################################
469## AVR32 Systems
470#########################################################################
471
Masahiro Yamada89487942013-10-21 11:11:28 +0900472LIST_avr32="$(targets_by_arch avr32)"
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200473
Aubrey.Lief26a082007-03-09 13:40:56 +0800474#########################################################################
475## Blackfin Systems
476#########################################################################
477
Masahiro Yamada89487942013-10-21 11:11:28 +0900478LIST_blackfin="$(targets_by_arch blackfin)"
Aubrey.Lief26a082007-03-09 13:40:56 +0800479
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100480#########################################################################
481## SH Systems
482#########################################################################
483
Masahiro Yamada89487942013-10-21 11:11:28 +0900484LIST_sh2="$(targets_by_cpu sh2)"
485LIST_sh3="$(targets_by_cpu sh3)"
486LIST_sh4="$(targets_by_cpu sh4)"
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700487
Masahiro Yamada89487942013-10-21 11:11:28 +0900488LIST_sh="$(targets_by_arch sh)"
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100489
Daniel Hellstromc2f02da2008-03-28 09:47:00 +0100490#########################################################################
491## SPARC Systems
492#########################################################################
493
Masahiro Yamada89487942013-10-21 11:11:28 +0900494LIST_sparc="$(targets_by_arch sparc)"
wdenk7ebf7442002-11-02 23:17:16 +0000495
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000496#########################################################################
497## NDS32 Systems
498#########################################################################
499
Masahiro Yamada89487942013-10-21 11:11:28 +0900500LIST_nds32="$(targets_by_arch nds32)"
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000501
Alexey Brodkin568c1fa2014-02-04 12:56:20 +0400502#########################################################################
503## ARC Systems
504#########################################################################
505
506LIST_arc="$(targets_by_arch arc)"
507
wdenk7ebf7442002-11-02 23:17:16 +0000508#-----------------------------------------------------------------------
509
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000510get_target_location() {
511 local target=$1
512 local BOARD_NAME=""
513 local CONFIG_NAME=""
514 local board=""
515 local vendor=""
516
517 # Automatic mode
Masahiro Yamada23d64102013-10-21 11:11:25 +0900518 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000519 if [ -z "${line}" ] ; then echo "" ; return ; fi
520
521 set ${line}
522
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900523 CONFIG_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000524
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900525 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000526
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200527 if [ $# -gt 5 ]; then
528 if [ "$6" = "-" ] ; then
529 board=${BOARD_NAME}
530 else
531 board="$6"
532 fi
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000533 fi
534
535 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200536 [ $# -gt 6 ] && [ "$8" != "-" ] && {
537 tmp="${8%:*}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000538 if [ "$tmp" ] ; then
539 CONFIG_NAME="$tmp"
540 fi
541 }
542
543 # Assign board directory to BOARDIR variable
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200544 if [ "${vendor}" == "-" ] ; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000545 BOARDDIR=${board}
546 else
547 BOARDDIR=${vendor}/${board}
548 fi
549
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200550 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000551}
552
553get_target_maintainers() {
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200554 local name=`echo $1 | cut -d : -f 3`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000555
Masahiro Yamada23d64102013-10-21 11:11:25 +0900556 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200557 if [ -z "${line}" ]; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000558 echo ""
559 return ;
560 fi
561
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200562 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
563 [ "$mails" == "-" ] && mails=""
564 echo "$mails"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000565}
566
Allen Martin47104c32013-01-29 14:34:58 +0000567get_target_arch() {
568 local target=$1
569
570 # Automatic mode
Masahiro Yamada54d1f502013-10-21 11:11:26 +0900571 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Allen Martin47104c32013-01-29 14:34:58 +0000572
573 if [ -z "${line}" ] ; then echo "" ; return ; fi
574
575 set ${line}
576 echo "$2"
577}
578
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000579list_target() {
580 if [ "$PRINT_MAINTS" != 'y' ] ; then
581 echo "$1"
582 return
583 fi
584
585 echo -n "$1:"
586
587 local loc=`get_target_location $1`
588
589 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
590
591 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
592
593 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
594
595 local dir=`echo ${loc} | cut -d ":" -f 2`
596 local cfg=`echo ${loc} | cut -d ":" -f 1`
597 local git_result=`git log --format=%aE board/${dir} \
598 include/configs/${cfg}.h | grep "@"`
599 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
600 head -n 3`
601 local git_result_top=`echo ${git_result} | tr " " "\n" | \
602 sort | uniq -c | sort -nr | head -n 3 | \
603 sed "s/^ \+[0-9]\+ \+//"`
604
605 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
606 sort -u | tr "\n" " " | sed "s/ $//" ;
607 else
608 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
609 sed "s/ $//" ;
610 fi
611
612 echo ""
613}
614
Andy Flemingf588bb02012-04-24 19:33:51 +0000615# Each finished build will have a file called ${donep}${n},
616# where n is the index of the build. Each build
617# we've already noted as finished will have ${skipp}${n}.
618# The code managing the build process will use this information
619# to ensure that only BUILD_NBUILDS builds are in flight at once
620donep="${LOG_DIR}/._done_"
621skipp="${LOG_DIR}/._skip_"
622
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000623build_target_killed() {
624 echo "Aborted $target build."
625 # Remove the logs for this board since it was aborted
626 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
627 exit
628}
629
wdenk7ebf7442002-11-02 23:17:16 +0000630build_target() {
631 target=$1
Andy Flemingf588bb02012-04-24 19:33:51 +0000632 build_idx=$2
633
Andy Flemingf50bf502012-05-09 20:36:28 +0000634 if [ "$ONLY_LIST" == 'y' ] ; then
635 list_target ${target}
636 return
637 fi
638
Andy Flemingf588bb02012-04-24 19:33:51 +0000639 if [ $BUILD_MANY == 1 ] ; then
640 output_dir="${OUTPUT_PREFIX}/${target}"
641 mkdir -p "${output_dir}"
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000642 trap build_target_killed TERM
Andy Flemingf588bb02012-04-24 19:33:51 +0000643 else
644 output_dir="${OUTPUT_PREFIX}"
645 fi
646
Allen Martin47104c32013-01-29 14:34:58 +0000647 target_arch=$(get_target_arch ${target})
York Sunc17b94e2013-03-22 07:37:03 +0000648 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
Allen Martin47104c32013-01-29 14:34:58 +0000649 if [ "${cross_toolchain}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900650 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
Allen Martin47104c32013-01-29 14:34:58 +0000651 elif [ "${CROSS_COMPILE}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900652 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
Allen Martin47104c32013-01-29 14:34:58 +0000653 else
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900654 MAKE=$GNU_MAKE
Allen Martin47104c32013-01-29 14:34:58 +0000655 fi
656
Masahiro Yamada9e414032014-02-04 17:24:24 +0900657 if [ "${output_dir}" != "." ] ; then
658 MAKE="${MAKE} O=${output_dir}"
659 fi
660
wdenk7ebf7442002-11-02 23:17:16 +0000661 ${MAKE} distclean >/dev/null
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900662
663 echo "Building ${target} board..."
664 ${MAKE} -s ${target}_defconfig >/dev/null
Marian Balakowiczf9328632006-09-01 19:49:50 +0200665
Kim Phillips33f336d2012-09-27 14:57:34 +0000666 ${MAKE} ${JOBS} ${CHECK} all \
Andy Flemingf588bb02012-04-24 19:33:51 +0000667 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tyserf2352872009-12-06 23:58:28 -0600668
669 # Check for 'make' errors
670 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
671 RC=1
672 fi
673
Andy Flemingf588bb02012-04-24 19:33:51 +0000674 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000675 trap - TERM
676
Masahiro Yamada73906432014-02-04 17:24:34 +0900677 ${MAKE} -s clean
Andy Flemingf588bb02012-04-24 19:33:51 +0000678
679 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000680 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
Andy Flemingf588bb02012-04-24 19:33:51 +0000681 else
682 rm ${LOG_DIR}/${target}.ERR
683 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500684 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000685 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000686 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
687 : $(( ERR_CNT += 1 ))
688 ERR_LIST="${ERR_LIST} $target"
689 else
690 : $(( WRN_CNT += 1 ))
691 WRN_LIST="${WRN_LIST} $target"
692 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000693 else
694 rm ${LOG_DIR}/${target}.ERR
695 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500696 fi
697
Andy Flemingf588bb02012-04-24 19:33:51 +0000698 OBJS=${output_dir}/u-boot
699 if [ -e ${output_dir}/spl/u-boot-spl ]; then
700 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
Scott Wood0c185692012-02-20 12:56:25 +0000701 fi
702
703 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
Andy Flemingf588bb02012-04-24 19:33:51 +0000704
705 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
706
Andy Flemingf588bb02012-04-24 19:33:51 +0000707 touch "${donep}${build_idx}"
wdenk7ebf7442002-11-02 23:17:16 +0000708}
Andy Flemingf588bb02012-04-24 19:33:51 +0000709
710manage_builds() {
711 search_idx=${OLDEST_IDX}
Andy Flemingf50bf502012-05-09 20:36:28 +0000712 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
713
Andy Flemingf588bb02012-04-24 19:33:51 +0000714 while true; do
715 if [ -e "${donep}${search_idx}" ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000716 : $(( CURRENT_CNT-- ))
717 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
718 : $(( OLDEST_IDX++ ))
719
720 # Only want to count it once
721 rm -f "${donep}${search_idx}"
722 touch "${skipp}${search_idx}"
723 elif [ -e "${skipp}${search_idx}" ] ; then
724 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
725 : $(( OLDEST_IDX++ ))
726 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000727 : $(( search_idx++ ))
728 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000729 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
730 search_idx=${OLDEST_IDX}
731 sleep 1
732 else
733 break
734 fi
735 fi
736 done
737}
738
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400739build_targets() {
740 for t in "$@" ; do
741 # If a LIST_xxx var exists, use it. But avoid variable
742 # expansion in the eval when a board name contains certain
743 # characters that the shell interprets.
744 case ${t} in
745 *[-+=]*) list= ;;
746 *) list=$(eval echo '${LIST_'$t'}') ;;
747 esac
748 if [ -n "${list}" ] ; then
749 build_targets ${list}
750 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000751 : $((TOTAL_CNT += 1))
752 : $((CURRENT_CNT += 1))
753 rm -f "${donep}${TOTAL_CNT}"
754 rm -f "${skipp}${TOTAL_CNT}"
Joe Hershberger08510202012-10-30 15:55:21 +0000755 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
756 : $((SKIP_CNT += 1))
757 touch "${donep}${TOTAL_CNT}"
758 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
759 : $((SKIP_CNT += 1))
760 touch "${donep}${TOTAL_CNT}"
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000761 else
Joe Hershberger08510202012-10-30 15:55:21 +0000762 if [ $BUILD_MANY == 1 ] ; then
763 build_target ${t} ${TOTAL_CNT} &
764 else
765 CUR_TGT="${t}"
766 build_target ${t} ${TOTAL_CNT}
767 CUR_TGT=''
768 fi
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000769 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000770 fi
771
772 # We maintain a running count of all the builds we have done.
773 # Each finished build will have a file called ${donep}${n},
774 # where n is the index of the build. Each build
775 # we've already noted as finished will have ${skipp}${n}.
776 # We track the current index via TOTAL_CNT, and the oldest
777 # index. When we exceed the maximum number of parallel builds,
778 # We look from oldest to current for builds that have completed,
779 # and update the current count and oldest index as appropriate.
780 # If we've gone through the entire list, wait a second, and
781 # reprocess the entire list until we find a build that has
782 # completed
783 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
784 manage_builds
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400785 fi
786 done
787}
wdenk7ebf7442002-11-02 23:17:16 +0000788
789#-----------------------------------------------------------------------
790
Andy Flemingf50bf502012-05-09 20:36:28 +0000791kill_children() {
Andreas Bießmann6bdd9f82013-02-07 22:35:57 +0000792 local OS=$(uname -s)
793 local children=""
794 case "${OS}" in
795 "Darwin")
796 # Mac OS X is known to have BSD style ps
797 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
798 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
799 ;;
800 *)
801 # everything else tries the GNU style
802 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
803 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
804 ;;
805 esac
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000806
807 kill $children 2> /dev/null
808 wait $children 2> /dev/null
Andy Flemingf50bf502012-05-09 20:36:28 +0000809
810 exit
811}
812
Peter Tyser40a28f02009-09-21 12:04:32 -0500813print_stats() {
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000814 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000815
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000816 # Only count boards that completed
817 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
818
Andy Flemingf588bb02012-04-24 19:33:51 +0000819 rm -f ${donep}* ${skipp}*
820
821 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
Andy Fleming033220e2012-08-08 14:12:30 +0000822 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000823 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
824 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
Andy Fleming033220e2012-08-08 14:12:30 +0000825 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000826 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
827 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000828 else
829 # Remove the logs for any board that was interrupted
830 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
Andy Flemingf588bb02012-04-24 19:33:51 +0000831 fi
832
Joe Hershberger08510202012-10-30 15:55:21 +0000833 : $((TOTAL_CNT -= ${SKIP_CNT}))
Peter Tyser40a28f02009-09-21 12:04:32 -0500834 echo ""
835 echo "--------------------- SUMMARY ----------------------------"
Joe Hershberger08510202012-10-30 15:55:21 +0000836 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
837 echo "Boards skipped: ${SKIP_CNT}"
838 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500839 echo "Boards compiled: ${TOTAL_CNT}"
840 if [ ${ERR_CNT} -gt 0 ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000841 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
842 fi
843 if [ ${WRN_CNT} -gt 0 ] ; then
844 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
Peter Tyser40a28f02009-09-21 12:04:32 -0500845 fi
846 echo "----------------------------------------------------------"
Peter Tyserf2352872009-12-06 23:58:28 -0600847
Andy Flemingf50bf502012-05-09 20:36:28 +0000848 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000849 kill_children
Andy Flemingf50bf502012-05-09 20:36:28 +0000850 fi
851
Peter Tyserf2352872009-12-06 23:58:28 -0600852 exit $RC
Peter Tyser40a28f02009-09-21 12:04:32 -0500853}
wdenk7ebf7442002-11-02 23:17:16 +0000854
Peter Tyser40a28f02009-09-21 12:04:32 -0500855#-----------------------------------------------------------------------
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400856
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200857# Build target groups selected by options, plus any command line args
858set -- ${SELECTED} "$@"
859# run PowerPC by default
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400860[ $# = 0 ] && set -- powerpc
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400861build_targets "$@"
Andy Flemingf588bb02012-04-24 19:33:51 +0000862wait